-----------------
-- Arcanroo V0.5
--
-- By Roobird
-- EU-Netherstorm
-----------------

local _
local Arcanroo_loaded = false




function Arcanroo_Resize(command)	


	if command == '+' then
		if Arcanroo_saved.size <= 2 then
			Arcanroo_saved.size = Arcanroo_saved.size + 0.25
			print("|cFF69CCF0 Arcanroo|r :: Upsized!");
		end
	end	
	if command == '-' then
		if Arcanroo_saved.size > 0.5 then
			Arcanroo_saved.size = Arcanroo_saved.size - 0.25
			print("|cFF69CCF0 Arcanroo|r :: Downsized!");
		end	
 	end


end



local function Arcanroo_slashhandler(msg, editbox)
 
	defaultslash = true ;	-- For Default Help
	 
 	if msg == '+' or msg == '-' then
		Arcanroo_Resize(msg);
		Arcanroo_Init();
		defaultslash = false;
 	end
 	
 	if msg == 'reset' or msg == 'r' then
 		
 		Arcanroo_saved.size = 1;
 		Arcanroo_Init();
		print("|cFF69CCF0 Arcanroo|r :: Resetted!");
		defaultslash = false;
	end  
	 	 	 	
 	if msg == 'lock' or msg == 'l' then
 		Arcanroo_saved.locked = true;
 		Arcanroo_Init(); 
		defaultslash = false; 
		print("|cFF69CCF0 Arcanroo|r :: Locked!");		
 	end
 	
 	if msg == 'unlock' or msg == 'ul' then
 		Arcanroo_saved.locked = false;
 		Arcanroo_Init(); 
		defaultslash = false; 	
		print("|cFF69CCF0 Arcanroo|r :: Unlocked!");	
 	end
 	
	if msg == 'hide' or msg == 'h' then
	  	Arcanroo_saved.show = false;
        Arcanroo_Init();   
	  	defaultslash = false;
	  	print("|cFF69CCF0 Arcanroo|r :: hide!");	
	end
	
	if msg == 'show' or msg == 's' then
	  	Arcanroo_saved.show = true;
	  	Arcanroo_Init();
	  	defaultslash = false;
		print("|cFF69CCF0 Arcanroo|r :: show!");	
 	end	

	if msg == 'help' or defaultslash then
		print('|cFF69CCF0 Arcanroo |r :: Help');
		print('-------------------------------');
		print('|cFF69CCF0 /aroo show |r (or s) to show the manaframe');
		print('|cFF69CCF0 /aroo hide |r (or h) to show the manaframe');
		print('|cFF69CCF0 /aroo lock|r (or l) to lock');
		print('|cFF69CCF0 /aroo unlock|r (or ul) to unlock');
		print('|cFF69CCF0 /aroo help|r to see this ;) ');
	end
		 
 	Arcanroo_Init(); 		

end

function Arcanroo_Localize() -- Localize 

	
	if Arcanroo_saved.dot_id == nil then
		Arcanroo_saved.dot_id = 114923
		print("Arcanroo setted NetherTempest to default Dot!")
	end
	
	Arcanroo_DOT, _, Arcanroo_DOTicon = GetSpellInfo(Arcanroo_saved.dot_id)
	
	Arcanroo_AC = GetSpellInfo(114664)
	
end






function Arcanroo_Options()	-- Options Entry

	local arcanroo_temp
	
	Arcanroo_OptionsFrame = CreateFrame("Frame", "Arcanroo_OptionsFrame", UIParent)
	Arcanroo_OptionsFrame:Hide()
	Arcanroo_OptionsFrame:SetWidth(300)
	Arcanroo_OptionsFrame:SetHeight(410)
	Arcanroo_OptionsFrame:SetFrameStrata("DIALOG")

	
	temp = Arcanroo_OptionsFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	temp:SetPoint("TOPLEFT", 20, -20)
	temp:SetText("Arcanroo Options")
	
	
	
	-- Hide
	Arcanroo_OptionsFrame_Hide = CreateFrame("CheckButton", "Arcanroo_OptionsFrame_Hide", Arcanroo_OptionsFrame, "InterfaceOptionsCheckButtonTemplate")
	Arcanroo_OptionsFrame_Hide:SetPoint("TOPLEFT", 20, -50)
	Arcanroo_OptionsFrame_Hide:SetHitRectInsets(0, -150, 0, 0)
	Arcanroo_OptionsFrame_HideText:SetText("Hide Arcanroo")
	Arcanroo_OptionsFrame_Hide:SetScript("OnClick", function(self)
		if Arcanroo_saved.show then
			Arcanroo_saved.show = false
		else
			Arcanroo_saved.show = true
		end
		Arcanroo_Init();
		Arcanroo_OptionsFrame_Hide:SetChecked((not Arcanroo_saved.show))
	end)	
	Arcanroo_OptionsFrame_Hide:SetChecked((not Arcanroo_saved.show))
	
	
	-- Locking
	Arcanroo_OptionsFrame_Locking = CreateFrame("CheckButton", "Arcanroo_OptionsFrame_Locking", Arcanroo_OptionsFrame, "InterfaceOptionsCheckButtonTemplate")
	Arcanroo_OptionsFrame_Locking:SetPoint("TOPLEFT", 20, -80)
	Arcanroo_OptionsFrame_Locking:SetHitRectInsets(0, -150, 0, 0)
	Arcanroo_OptionsFrame_LockingText:SetText("Lock Arcanroo")
	Arcanroo_OptionsFrame_Locking:SetScript("OnClick", function(self)
		if Arcanroo_saved.locked then
			Arcanroo_saved.locked = false
		else
			Arcanroo_saved.locked = true
		end
		Arcanroo_Init();
		Arcanroo_OptionsFrame_Locking:SetChecked(Arcanroo_saved.locked)	
	end)
	Arcanroo_OptionsFrame_Locking:SetChecked(Arcanroo_saved.locked)	
	
	
	-- Fullstack sound
	Arcanroo_OptionsFrame_FSS = CreateFrame("CheckButton", "Arcanroo_OptionsFrame_FSS", Arcanroo_OptionsFrame, "InterfaceOptionsCheckButtonTemplate")
	Arcanroo_OptionsFrame_FSS:SetPoint("TOPLEFT", 20, -110)
	Arcanroo_OptionsFrame_FSS:SetHitRectInsets(0, -150, 0, 0)
	Arcanroo_OptionsFrame_FSSText:SetText("Fullstack sound")
	Arcanroo_OptionsFrame_FSS:SetScript("OnClick", function(self)
		if Arcanroo_saved.FSsound then
			Arcanroo_saved.FSsound = false
		else
			Arcanroo_saved.FSsound = true
		end
		Arcanroo_Init();
		Arcanroo_OptionsFrame_FSS:SetChecked(Arcanroo_saved.FSsound)	
	end)
	Arcanroo_OptionsFrame_FSS:SetChecked(Arcanroo_saved.FSsound)	


	-- Size
	
	Arcanroo_SizeSlider = CreateFrame("Slider", "Arcanroo_SizeSlider", Arcanroo_OptionsFrame, "OptionsSliderTemplate")
	Arcanroo_SizeSlider:SetWidth(200)
	Arcanroo_SizeSlider:SetHeight(16)
	Arcanroo_SizeSlider:SetPoint("TOPLEFT", 20, -160)
	Arcanroo_SizeSliderLow:SetText("50%")
	Arcanroo_SizeSliderHigh:SetText("200%")
	Arcanroo_SizeSlider:SetMinMaxValues(0.5, 2)
	Arcanroo_SizeSlider:SetValueStep(0.25)
	Arcanroo_SizeSlider:SetScript("OnValueChanged", function(self, value)
		Arcanroo_SizeSliderText:SetFormattedText("Size %d%%", (value*100))
		Arcanroo_saved.size = value
		Arcanroo_Init();
		Arcanroo_SizeSlider:SetValue(Arcanroo_saved.size)
	end)
	Arcanroo_SizeSlider:SetValue(Arcanroo_saved.size)
	
	
	
	-- DOT Selection
	
	local Arcanroo_DOTspells = {
	
--[[	Arcanroo_NT = GetSpellInfo(114923),	-- Nether Tempest
	Arcanroo_LB = GetSpellInfo(44457),	-- Living Bomb
	Arcanroo_FB = GetSpellInfo(113092),	-- Frost Bomb
 ]]--
 	"DoT: Nether Tempest",
 	"DoT: Living Bomb",
 	"DoT: Frost Bomb", 	  	
   	
	}
	
	
	
	Arcanroo_DOTSelection = CreateFrame("Frame", "Arcanroo_DOTSelection", Arcanroo_OptionsFrame, "UIDropDownMenuTemplate")
	Arcanroo_DOTSelection:SetPoint("TOPLEFT", 5, -210)
	Arcanroo_DOTSelection:SetHitRectInsets(16, 16, 0, 0)
	UIDropDownMenu_SetWidth(Arcanroo_DOTSelection, 250)
	UIDropDownMenu_EnableDropDown(Arcanroo_DOTSelection)
	UIDropDownMenu_JustifyText(Arcanroo_DOTSelection, "LEFT")
	Arcanroo_DOTSelection:CreateFontString("Arcanroo_DOTSelectionLabel", "BACKGROUND", "GameFontNormalSmall")
	Arcanroo_DOTSelectionLabel:SetPoint("BOTTOMLEFT", Arcanroo_DOTSelection, "TOPLEFT", 21, 1)
	Arcanroo_DOTSelectionLabel:SetText("DoT-Selection")
	Arcanroo_DOTSelectionText:SetText("DoT: " .. Arcanroo_DOT)

	local function OnClick(self)

   		
   		UIDropDownMenu_SetSelectedID(Arcanroo_DOTSelection, self:GetID())

   		if UIDropDownMenu_GetSelectedID(Arcanroo_DOTSelection) == 1 then
   			Arcanroo_saved.dot_id = 114923			-- NT
   		end
   		if UIDropDownMenu_GetSelectedID(Arcanroo_DOTSelection) == 2 then
   			Arcanroo_saved.dot_id = 44457			-- LB
   		end
   		if UIDropDownMenu_GetSelectedID(Arcanroo_DOTSelection) == 3 then
   			Arcanroo_saved.dot_id = 113092			-- FB
   		end
   		
   		Arcanroo_DOT, _, Arcanroo_DOTicon = GetSpellInfo(Arcanroo_saved.dot_id)
		Arcanroo_Init();
   		
	end
 
	local function initialize(self, level)
   		local info = UIDropDownMenu_CreateInfo()
   		for k,v in pairs(Arcanroo_DOTspells) do
      		info = UIDropDownMenu_CreateInfo()
      		info.text = v
      		info.value = v
      		info.func = OnClick
      		UIDropDownMenu_AddButton(info, level)
   		end
	end
 
 	UIDropDownMenu_Initialize(Arcanroo_DOTSelection, initialize)



	-- Add to Interface Options
	Arcanroo_OptionsFrame.name = "Arcanroo"
	InterfaceOptions_AddCategory(Arcanroo_OptionsFrame)

end


function Arcanroo_Load()		
 	
  	print ("|cFF69CCF0 Arcanroo |rV0.3|cFFFF0000 loaded.");
  	print ("|r|rUse|cFF69CCF0 /aroo|r for help!");


	-- Arcanroo_Mana:SetFont("Interface\\AddOns\\Arcanroo\\font\\comic.ttf", 72, "OUTLINE")
	
--		Arcanroo_Mana:SetTextHeight(36);	
--    Arcanroo_Dottimer:SetTextHeight(36);
  --  Arcanroo_Debuffstack:SetTextHeight(36);
	Arcanroo_Debuff:Hide();
	Arcanroo_FullStack:Hide();


	if Arcanroo_saved == nil then
		  	
	  	Arcanroo_saved = {
	  	
  		show = true;
  		size = 1;
  		locked = false;
  		dot_id = 114923; -- Nether Tempest
  		FSsound = true;
 		  	
 	  	}
 	
	 	if Arcanroo_saved.FSsound == nil then
	 		Arcanroo_saved.FSsound = true
	 	end
 		
	    print ("|cFF69CCF0 Arcanroo |r:: First time loaded!");

	end	
  
	Arcanroo_Localize();
	Arcanroo_Init();	
	Arcanroo_Options();
	

	Arcanroo_loaded = true;
	 
	
	
          	
end


function Arcanroo_Init()

 
  		if Arcanroo_saved.show == false then
      		ArcanrooForm:Hide();
  		else
  			ArcanrooForm:Show();
  		end
 
  		
  		if Arcanroo_saved.locked then
  			ArcanrooForm:EnableMouse(false);
  		else
  			ArcanrooForm:EnableMouse(true);
  		end
  		
  		
  		-- Resizing --
  		ArcanrooForm:SetWidth(100 * Arcanroo_saved.size)
		ArcanrooForm:SetHeight(80 * Arcanroo_saved.size)
		
		Arcanroo_Debuff:SetWidth(40 * Arcanroo_saved.size)
		Arcanroo_Debuff:SetHeight(40 * Arcanroo_saved.size)
		
		Arcanroo_Dot:SetWidth(40 * Arcanroo_saved.size)
		Arcanroo_Dot:SetHeight(40 * Arcanroo_saved.size)
		Arcanroo_DotTexture:SetTexture(Arcanroo_DOTicon)
		
		Arcanroo_FullStack:SetWidth(140 * Arcanroo_saved.size)
		Arcanroo_FullStack:SetHeight(160 * Arcanroo_saved.size)
		
		
		Arcanroo_Mana:SetTextHeight(36 * Arcanroo_saved.size)
   		Arcanroo_Dottimer:SetTextHeight(30 * Arcanroo_saved.size);
   		Arcanroo_Debuffstack:SetTextHeight(30 * Arcanroo_saved.size);
    

   		 		

end



function Arcanroo_Run()


	if Arcanroo_loaded == true and Arcanroo_saved.show == true then


		-- Mana Tracker --
		
		arcanroo_mana = UnitPower("player", 0);
		arcanroo_manamax = UnitPowerMax("player", 0);
		arcanroo_manacur = (arcanroo_mana/arcanroo_manamax)* 100 ;
		arcanroo_manacur = floor(arcanroo_manacur);
		  
  		if  arcanroo_manacur> 89 then	
    
    		Arcanroo_Mana:SetTextColor(0, 1, 0, 1);
    		Arcanroo_Mana:SetText(arcanroo_manacur.." %");
  		end
      
  		if arcanroo_manacur < 35 then 
  
    		Arcanroo_Mana:SetTextColor(1, 0, 0, 1);
    		Arcanroo_Mana:SetText(arcanroo_manacur.." %");
  		end
  
 	 	if arcanroo_manacur < 90 and arcanroo_manacur > 34 then
      
    		Arcanroo_Mana:SetTextColor(1, 1, 1, 1);
    		Arcanroo_Mana:SetText(arcanroo_manacur.." %");
  		end
  		
  	  	
  	  	-- NetherTempestDot Tracker --
  	  	
  		Arcanroo_DOTdebuffUP,_,_,_,_,_,Arcanroo_expTime = UnitAura("target", Arcanroo_DOT , nil , "PLAYER|HARMFUL")
  				  		
  		if Arcanroo_DOTdebuffUP == nil then
  			Arcanroo_Dottimer:SetText(" ");
  			Arcanroo_Dot:SetAlpha(1);
  			Arcanroo_Dot:Show();
  		else
  			Arcanroo_DotTime = Arcanroo_expTime - GetTime()  -- Debuff time
  			Arcanroo_Dot:Hide();
  			if Arcanroo_DotTime <= 5 then
  				Arcanroo_Dot:Show();
  				Arcanroo_Dot:SetAlpha(1.5/Arcanroo_DotTime);
  				Arcanroo_Dottimer:SetText(floor(Arcanroo_DotTime));
  			end	
  		end
 
 		-- ArcanCharges Tracker--
 		
  		Arcanroo_buff,_,_,Arcanroo_Stacks = UnitAura("player", Arcanroo_AC, nil, "PLAYER|HARMFUL")		
		
		if Arcanroo_buff == nil then
			Arcanroo_Debuffstack:SetText( " " );
			Arcanroo_Debuff:Hide();
			Arcanroo_FullStack:Hide();
			Arcanroo_sound_played = false;
		else
			Arcanroo_Debuff:Show();
			Arcanroo_Debuffstack:SetText(Arcanroo_Stacks);
			if Arcanroo_Stacks == 6 then
				Arcanroo_FullStack:Show();
				
				if Arcanroo_sound_played == false and Arcanroo_saved.FSsound == true then
					PlaySoundFile("Sound\\Event\\Event_THIntro_FirstShipExplo.ogg", "Master")
					Arcanroo_sound_played = true
				end
				
				if fx_do == nil then
				 	fx_do = true
				 	fx_i = 20
				end
				if fx_do then
					if fx_i < 1 then
						fx_do = false
					else
						fx_i = fx_i - 1
					end
				else
					if fx_i > 18 then
						fx_do = true
					else
						fx_i = fx_i + 1
					end
				end
				Arcanroo_FullStack:SetAlpha(fx_i/20)
			end
		end
		
		
	end

end





SLASH_ARCANROO1, SLASH_ARCANROO2 = '/arcanroo', '/aroo';
SlashCmdList["ARCANROO"] = Arcanroo_slashhandler;
